openshot::EffectBase Class Referenceabstract

This abstract class is the base class, used by all effects in libopenshot. More...

`#include <EffectBase.h>`

Inheritance diagram for openshot::EffectBase:

## Public Member Functions

int | constrain (int color_value)
| Constrain a color value from 0 to 255. More...
void | DisplayInfo ()
| Display effect information in the standard output stream (stdout) More...
virtual std::shared_ptr< Frame > | GetFrame (std::shared_ptr< Frame > frame, int64_t frame_number)=0
| This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object. More...
void | InitEffectInfo ()
virtual string | Json ()=0
| Get and Set JSON methods. More...
Json::Value | JsonInfo ()
| Generate JSON object of meta data / info. More...
virtual Json::Value | JsonValue ()=0
| Generate Json::JsonValue for this object. More...
int | Order ()
| Get the order that this effect should be executed. More...
void | Order (int new_order)
| Set the order that this effect should be executed. More...
virtual void | SetJson (string value)=0
| Load JSON string into this object. More...
virtual void | SetJsonValue (Json::Value root)=0
| Load Json::JsonValue into this object. More...
Public Member Functions inherited from openshot::ClipBase
| ClipBase ()
| Constructor for the base clip. More...
void | Id (string value)
| Set basic properties. More...
bool | operator< (ClipBase &a)
bool | operator<= (ClipBase &a)
bool | operator> (ClipBase &a)
bool | operator>= (ClipBase &a)
virtual string | PropertiesJSON (int64_t requested_frame)=0
void | SetMaxSize (int width, int height)
| Set Max Image Size (used for performance optimization) More...

## Public Attributes

EffectInfoStruct | info
| Information about the current effect. More...

## Additional Inherited Members

Protected Member Functions inherited from openshot::ClipBase
Json::Value | add_property_choice_json (string name, int value, int selected_value)
| Generate JSON choice for a property (dropdown properties) More...
Json::Value | add_property_json (string name, float value, string type, string memo, Keyframe *keyframe, float min_value, float max_value, bool readonly, int64_t requested_frame)
| Generate JSON for a property. More...
Protected Attributes inherited from openshot::ClipBase
float | end
| The position in seconds to end playing (used to trim the ending of a clip) More...
string | id
| ID Property for all derived Clip and Effect classes. More...
int | layer
| The layer this clip is on. Lower clips are covered up by higher clips. More...
int | max_height
| The maximium image height needed by this clip (used for optimizations) More...
int | max_width
| The maximum image width needed by this clip (used for optimizations) More...
float | position
| The position on the timeline where this clip should start playing. More...
string | previous_properties
| This string contains the previous JSON properties. More...
float | start
| The position in seconds to start playing (used to trim the beginning of a clip) More...

## Detailed Description

This abstract class is the base class, used by all effects in libopenshot.

Effects are types of classes that manipulate the image or audio data of an openshot::Frame object. The only requirements for an 'effect', is to derive from this base class, implement the Apply() method, and call the InitEffectInfo() method.

Definition at line 66 of file EffectBase.h.

## Member Function Documentation

## constrain()

int EffectBase::constrain | ( | int | color_value | ) |

Constrain a color value from 0 to 255.

Definition at line 62 of file EffectBase.cpp.

## DisplayInfo()

void EffectBase::DisplayInfo | ( |  | ) |

Display effect information in the standard output stream (stdout)

Definition at line 49 of file EffectBase.cpp.

## GetFrame()

virtual std::shared_ptr<Frame> openshot::EffectBase::GetFrame | ( | std::shared_ptr< Frame > | frame,
|  | int64_t | frame_number
| ) |  |

pure virtual

This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object.

The frame object is passed into this method, and a frame_number is passed in which tells the effect which settings to use from it's keyframes (starting at 1).

Returns
  The modified openshot::Frame object

Parameters

  frame | The frame object that needs the effect applied to it
  frame_number | The frame number (starting at 1) of the effect on the timeline.

Implemented in openshot::Blur, openshot::Mask, openshot::ColorShift, openshot::Bars, openshot::Brightness, openshot::Crop, openshot::Pixelate, openshot::Wave, openshot::ChromaKey, openshot::Saturation, openshot::Deinterlace, openshot::Shift, openshot::Hue, and openshot::Negate.

## InitEffectInfo()

void EffectBase::InitEffectInfo | ( |  | ) |

Initialize the values of the EffectInfo struct. It is important for derived classes to call this method, or the EffectInfo struct values will not be initialized.

Definition at line 33 of file EffectBase.cpp.

## Json()

string EffectBase::Json | ( |  | ) |

pure virtual

Get and Set JSON methods.

Generate JSON string of this object

Implements openshot::ClipBase.

Implemented in openshot::Blur, openshot::Mask, openshot::ColorShift, openshot::Bars, openshot::Brightness, openshot::Crop, openshot::Pixelate, openshot::Wave, openshot::ChromaKey, openshot::Saturation, openshot::Deinterlace, openshot::Shift, openshot::Hue, and openshot::Negate.

Definition at line 74 of file EffectBase.cpp.

## JsonInfo()

Json::Value EffectBase::JsonInfo | ( |  | ) |

Generate JSON object of meta data / info.

Definition at line 132 of file EffectBase.cpp.

## JsonValue()

Json::Value EffectBase::JsonValue | ( |  | ) |

pure virtual

Generate Json::JsonValue for this object.

Implements openshot::ClipBase.

Implemented in openshot::Blur, openshot::Mask, openshot::ColorShift, openshot::Bars, openshot::Brightness, openshot::Crop, openshot::Pixelate, openshot::Wave, openshot::ChromaKey, openshot::Saturation, openshot::Deinterlace, openshot::Shift, openshot::Hue, and openshot::Negate.

Definition at line 81 of file EffectBase.cpp.

## Order() [1/2]

int openshot::EffectBase::Order | ( |  | ) |

inline

Get the order that this effect should be executed.

Definition at line 104 of file EffectBase.h.

## Order() [2/2]

void openshot::EffectBase::Order | ( | int | new_order | ) |

inline

Set the order that this effect should be executed.

Definition at line 107 of file EffectBase.h.

## SetJson()

void EffectBase::SetJson | ( | string | value | ) |

pure virtual

Load JSON string into this object.

Implements openshot::ClipBase.

Implemented in openshot::Blur, openshot::Mask, openshot::ColorShift, openshot::Bars, openshot::Brightness, openshot::Crop, openshot::Pixelate, openshot::Wave, openshot::ChromaKey, openshot::Saturation, openshot::Deinterlace, openshot::Shift, openshot::Hue, and openshot::Negate.

Definition at line 98 of file EffectBase.cpp.

## SetJsonValue()

void EffectBase::SetJsonValue | ( | Json::Value | root | ) |

pure virtual

Load Json::JsonValue into this object.

Implements openshot::ClipBase.

Implemented in openshot::Blur, openshot::Mask, openshot::ColorShift, openshot::Bars, openshot::Brightness, openshot::Crop, openshot::Pixelate, openshot::Wave, openshot::ChromaKey, openshot::Saturation, openshot::Deinterlace, openshot::Shift, openshot::Hue, and openshot::Negate.

Definition at line 121 of file EffectBase.cpp.

## Member Data Documentation

## info

EffectInfoStruct openshot::EffectBase::info

Information about the current effect.

Definition at line 73 of file EffectBase.h.

The documentation for this class was generated from the following files:

- EffectBase.h
- EffectBase.cpp